	cpu LMM
	.module lsm303dlm.c
	.area text(rom, con, rel)
	.dbfile ./lsm303dlm.c
	.dbfunc e delay_us _delay_us fV
_delay_us::
	.dbline -1
	.dbline 24
; #include "psocgpioint.h"
; #include "lsm303dlm.h"
; #include "types_n_macros.h"
; //-----------------------------------------------------------------------
; //
; // IMPORTANT!!! 
; // SDATA must be set in Pull-up mode to act as a bidirectional port. SDATA must be set to 1 to enable input mode!
; // SCLK is set to output. 
; //
; //-----------------------------------------------------------------------
; // I2C bus base addresses
; 
; #define I2C_ACC_ADDR_W 0x32
; #define I2C_ACC_ADDR_R 0x33
; 
; #define I2C_MAG_ADDR_W 0x3C
; #define I2C_MAG_ADDR_R 0x3D
; 
; //-----------------------------------------------------------------------
; // I2C software implementation for LSM303
; //-----------------------------------------------------------------------
; 
; void delay_us( void )
; {
	.dbline 29
; //unsigned char i;
; // Ugly active waiting to meet I2C timings 
; //for (i = 0; i < TIMING_DELAY; i++){;}	
; //DELAY_12CYCLES
; DELAY_4CYCLES 
		NOP

	.dbline -2
	.dbline 31
; 
; }
L1:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_Start _I2C_Start fV
_I2C_Start::
	.dbline -1
	.dbline 34
; //-----------------------------------------------------------------------
; void I2C_Start( void )
; {
	.dbline 35
; GPIO_HIGH(SDATA);
	or REG[0x8],64
	.dbline 35
	.dbline 36
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 36
	.dbline 38
; 
; delay_us();
	xcall _delay_us
	.dbline 39
; GPIO_LOW(SDATA);
	and REG[0x8],-65
	.dbline 39
	.dbline 40
; delay_us();
	xcall _delay_us
	.dbline 41
; GPIO_LOW(SCLK);
	and REG[0x8],-17
	.dbline 41
	.dbline 42
; delay_us();
	xcall _delay_us
	.dbline -2
	.dbline 44
; 
; }
L2:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_RepeatStart _I2C_RepeatStart fV
_I2C_RepeatStart::
	.dbline -1
	.dbline 47
; //-----------------------------------------------------------------------
; void I2C_RepeatStart( void )
; {
	.dbline 50
; //unsigned char i; 
; 
; GPIO_HIGH(SDATA);
	or REG[0x8],64
	.dbline 50
	.dbline 51
; delay_us();
	xcall _delay_us
	.dbline 52
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 52
	.dbline 54
; 
; delay_us();
	xcall _delay_us
	.dbline 55
; GPIO_LOW(SDATA);
	and REG[0x8],-65
	.dbline 55
	.dbline 56
; delay_us();
	xcall _delay_us
	.dbline 57
; GPIO_LOW(SCLK);
	and REG[0x8],-17
	.dbline 57
	.dbline 58
; delay_us();
	xcall _delay_us
	.dbline -2
	.dbline 60
; 
; }
L3:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_Stop _I2C_Stop fV
_I2C_Stop::
	.dbline -1
	.dbline 63
; //-----------------------------------------------------------------------
; void I2C_Stop( void )
; {
	.dbline 64
; GPIO_LOW(SDATA);
	and REG[0x8],-65
	.dbline 64
	.dbline 65
; delay_us();
	xcall _delay_us
	.dbline 67
; 
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 67
	.dbline 68
; delay_us();
	xcall _delay_us
	.dbline 70
; 
; GPIO_HIGH(SDATA);
	or REG[0x8],64
	.dbline 70
	.dbline 71
; delay_us();
	xcall _delay_us
	.dbline -2
	.dbline 72
; }
L4:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_TxByte _I2C_TxByte fV
;           mask -> X+1
;              i -> X+0
;           data -> X-4
_I2C_TxByte::
	.dbline -1
	push X
	mov X,SP
	add SP,2
	.dbline 75
; //-----------------------------------------------------------------------
; void I2C_TxByte( unsigned char data )
; {
	.dbline 77
; unsigned char i;
; unsigned char mask = 0x80; // MSB first!
	mov [X+1],-128
	.dbline 79
; 
; for (i = 0; i < 8; i++)
	mov [X+0],0
	xjmp L9
L6:
	.dbline 80
; {
	.dbline 81
; 	if (data & mask)
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,[X+1]
	cmp A,0
	jz L10
	.dbline 82
; 	{
	.dbline 83
; 	 	GPIO_HIGH(SDATA);
	or REG[0x8],64
	.dbline 83
	.dbline 84
; 	}
	xjmp L11
L10:
	.dbline 86
; 	else 
; 	{
	.dbline 87
; 		GPIO_LOW(SDATA);
	and REG[0x8],-65
	.dbline 87
	.dbline 88
; 	}
L11:
	.dbline 89
	and F,-5
	rrc [X+1]
	.dbline 93
	or REG[0x8],16
	.dbline 93
	.dbline 94
	xcall _delay_us
	.dbline 95
	xcall _delay_us
	.dbline 97
	and REG[0x8],-17
	.dbline 97
	.dbline 98
	xcall _delay_us
	.dbline 99
L7:
	.dbline 79
	inc [X+0]
L9:
	.dbline 79
	cmp [X+0],8
	jc L6
X0:
	.dbline -2
	.dbline 101
; 	mask >>= 0x01;
; 	
; 	//delay_us();
; 
; 	GPIO_HIGH(SCLK);
; 	delay_us();
; 	delay_us();
; 
; 	GPIO_LOW(SCLK);
; 	delay_us(); 
; }
; 
; }
L5:
	add SP,-2
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l mask 1 c
	.dbsym l i 0 c
	.dbsym l data -4 c
	.dbend
	.dbfunc e I2C_RxByte _I2C_RxByte fc
;              t -> X+2
;           data -> X+1
;              i -> X+0
_I2C_RxByte::
	.dbline -1
	push X
	mov X,SP
	add SP,3
	.dbline 104
; //-----------------------------------------------------------------------
; unsigned char I2C_RxByte( void )
; {
	.dbline 106
; 
; unsigned char t, data = 0x00;
	mov [X+1],0
	.dbline 109
; unsigned char i;
; 
; GPIO_HIGH(SDATA); // To set the port in pseudo input
	or REG[0x8],64
	.dbline 109
	.dbline 111
; 
; PRT2DM0 &= 0xbf;
	or F,0x10  ; iopage = 1
	and REG[0x8],-65
	and F,0xEF ; iopage = 0
	.dbline 113
; 
; for (i = 0; i < 8; i++)
	mov [X+0],0
	xjmp L16
L13:
	.dbline 114
; {
	.dbline 115
; 	delay_us();
	xcall _delay_us
	.dbline 117
; 
; 	GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 117
	.dbline 119
; 	// Latch data bit... MSB first!
; 	delay_us();
	xcall _delay_us
	.dbline 120
; 	data <<= 0x01;
	asl [X+1]
	.dbline 121
; 	if (SDATA_Data_ADDR & SDATA_MASK) data |= 0x01; 
	tst REG[0x8],64
	jz L17
	.dbline 121
	mov REG[0xd0],>__r0
	mov A,[X+1]
	or A,1
	mov [X+1],A
L17:
	.dbline 122
	xcall _delay_us
	.dbline 123
	and REG[0x8],-17
	.dbline 123
	.dbline 124
	xcall _delay_us
	.dbline 125
L14:
	.dbline 113
	inc [X+0]
L16:
	.dbline 113
	cmp [X+0],8
	jc L13
X1:
	.dbline 127
; 	delay_us();
; 	GPIO_LOW(SCLK);
; 	delay_us(); 
; }
; 
; PRT2DM0 |= 0x40;
	or F,0x10  ; iopage = 1
	or REG[0x8],64
	and F,0xEF ; iopage = 0
	.dbline 129
;  
; return data;
	mov A,[X+1]
	mov REG[0xd0],>__r0
	.dbline -2
L12:
	add SP,-3
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l t 2 c
	.dbsym l data 1 c
	.dbsym l i 0 c
	.dbend
	.dbfunc e I2C_SlaveAck _I2C_SlaveAck fV
_I2C_SlaveAck::
	.dbline -1
	.dbline 133
; }
; //-----------------------------------------------------------------------
; void I2C_SlaveAck( void )
; {
	.dbline 137
; // Slave acknowledge == Set SDATA as input and generate one clock. Slave sets SDATA to low.
; // SDATA Check not implemented. 
; 
; GPIO_HIGH(SDATA); // To set the port in pseudo input
	or REG[0x8],64
	.dbline 137
	.dbline 139
; 
; delay_us();
	xcall _delay_us
	.dbline 141
; 
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 141
	.dbline 142
; delay_us();
	xcall _delay_us
	.dbline 143
; delay_us();
	xcall _delay_us
	.dbline 145
; 
; GPIO_LOW(SCLK);
	and REG[0x8],-17
	.dbline 145
	.dbline 146
; delay_us(); 
	xcall _delay_us
	.dbline -2
	.dbline 148
; 
; }
L19:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_MasterAck _I2C_MasterAck fV
_I2C_MasterAck::
	.dbline -1
	.dbline 151
; //-----------------------------------------------------------------------
; void I2C_MasterAck( void )
; {
	.dbline 153
; 
; GPIO_LOW(SDATA);
	and REG[0x8],-65
	.dbline 153
	.dbline 155
; 
; delay_us();
	xcall _delay_us
	.dbline 157
; 
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 157
	.dbline 158
; delay_us();
	xcall _delay_us
	.dbline 159
; delay_us();
	xcall _delay_us
	.dbline 161
; 
; GPIO_LOW(SCLK);
	and REG[0x8],-17
	.dbline 161
	.dbline 162
; delay_us(); 
	xcall _delay_us
	.dbline -2
	.dbline 163
; }
L20:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e I2C_MasterNack _I2C_MasterNack fV
_I2C_MasterNack::
	.dbline -1
	.dbline 166
; //-----------------------------------------------------------------------
; void I2C_MasterNack( void )
; {
	.dbline 167
; GPIO_HIGH(SDATA); 
	or REG[0x8],64
	.dbline 167
	.dbline 169
; 
; delay_us();
	xcall _delay_us
	.dbline 171
; 
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 171
	.dbline 172
; delay_us();
	xcall _delay_us
	.dbline 173
; delay_us();
	xcall _delay_us
	.dbline 175
; 
; GPIO_LOW(SCLK);
	and REG[0x8],-17
	.dbline 175
	.dbline 176
; delay_us(); 
	xcall _delay_us
	.dbline -2
	.dbline 177
; }
L21:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LSM303_Start _LSM303_Start fV
_LSM303_Start::
	.dbline -1
	.dbline 180
; //-----------------------------------------------------------------------
; void LSM303_Start( void )
; {
	.dbline 182
; // Gives a I2C Stop for init...
; GPIO_HIGH(SCLK);
	or REG[0x8],16
	.dbline 182
	.dbline 183
; GPIO_HIGH(SDATA);
	or REG[0x8],64
	.dbline 183
	.dbline 189
; 
; // The acceleration sensor is in Power Down mode at reset!
; // -> CTRL_REG1_A must be written with proper value to stratup the sensor!	
; //LSM303_TxReg_Acc(0x20, 0x3f); // PM = 1 + all axes enabled + freq = 1kHz --- NOTE: 1kHz and 400Hz do not seem to work!!!
; 
; LSM303_TxReg_Acc(0x20, 0x2f); // PM = 1 + all axes enabled + freq = 100Hz
	mov A,47
	push A
	mov A,32
	push A
	xcall _LSM303_TxReg_Acc
	.dbline 190
; LSM303_TxReg_Acc(0x21, 0x00); // HF filter off
	mov A,0
	push A
	mov A,33
	push A
	xcall _LSM303_TxReg_Acc
	add SP,-4
	.dbline 191
; LSM303_TxReg_Acc(0x23, 0x80); // BUD to one to prevent changes between LSB and MSB readings...
	mov A,-128
	push A
	mov A,35
	push A
	xcall _LSM303_TxReg_Acc
	.dbline 196
; 
; // The magnetic sensor is in sleep mode at reset!
; // -> MR_REG_M must be written with proper value to stratup the sensor!
; 
; LSM303_TxReg_Mag(0x00, 0x18); // Set the max bandwidth!!!
	mov A,24
	push A
	mov A,0
	push A
	xcall _LSM303_TxReg_Mag
	add SP,-4
	.dbline 197
; LSM303_TxReg_Mag(0x01, 0x60); // Set device gain -> +/- 2.5G
	mov A,96
	push A
	mov A,1
	push A
	xcall _LSM303_TxReg_Mag
	.dbline 198
; LSM303_TxReg_Mag(0x02, 0x00); // Mode set to continuous mode
	mov A,0
	push A
	mov A,2
	push A
	xcall _LSM303_TxReg_Mag
	add SP,-4
	.dbline -2
	.dbline 199
; }
L22:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LSM303_Stop _LSM303_Stop fV
_LSM303_Stop::
	.dbline -1
	.dbline 202
; //-----------------------------------------------------------------------
; void LSM303_Stop( void )
; {
	.dbline 204
; // Set acceleration sensor in Power down + disable all axes
; LSM303_TxReg_Acc(0x20, 0x00);
	mov A,0
	push A
	mov A,32
	push A
	xcall _LSM303_TxReg_Acc
	.dbline 207
; 
; // Set magnetic sensor to sleep mode
; LSM303_TxReg_Mag(0x02, 0x03);
	mov A,3
	push A
	mov A,2
	push A
	xcall _LSM303_TxReg_Mag
	add SP,-4
	.dbline -2
	.dbline 208
; }
L23:
	.dbline 0 ; func end
	ret
	.dbend
	.dbfunc e LSM303_TxReg_Acc _LSM303_TxReg_Acc fV
;           data -> X-5
;        address -> X-4
_LSM303_TxReg_Acc::
	.dbline -1
	push X
	mov X,SP
	.dbline 213
; //-----------------------------------------------------------------------
; // Acceleration sensor access functions
; //-----------------------------------------------------------------------
; void LSM303_TxReg_Acc(unsigned char address, unsigned char data)
; {
	.dbline 222
; 
; // Check that the target address is not reserved!!!
; // Writing to these registers could damage the device!!!
; //if (address < 0x20) return;
; //if ((address > 0x2D) && (address < 0x30)) return;
; //if (address > 0x37) return;
; 
; // I2C communication
; I2C_Start();
	xcall _I2C_Start
	.dbline 225
; 
; // Write device address
; I2C_TxByte(I2C_ACC_ADDR_W);
	mov A,50
	push A
	xcall _I2C_TxByte
	add SP,-1
	.dbline 226
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 229
; 
; // Write register address
; I2C_TxByte(address);
	mov A,[X-4]
	push A
	xcall _I2C_TxByte
	.dbline 230
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 233
; 
; // Write register value
; I2C_TxByte(data);
	mov A,[X-5]
	push A
	xcall _I2C_TxByte
	add SP,-2
	.dbline 234
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 236
; 
; I2C_Stop();
	xcall _I2C_Stop
	.dbline -2
	.dbline 237
; }
L24:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l data -5 c
	.dbsym l address -4 c
	.dbend
	.dbfunc e LSM303_RxReg_Acc _LSM303_RxReg_Acc fc
;              d -> X+0
;        address -> X-4
_LSM303_RxReg_Acc::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 240
; //-----------------------------------------------------------------------
; unsigned char LSM303_RxReg_Acc(unsigned char address)
; {
	.dbline 241
; unsigned char d = 0x00;
	mov [X+0],0
	.dbline 250
; 
; // Check that the target address is not reserved!!!
; // Writing to these registers could damage the device!!!
; //if (address < 0x20) return 0;
; //if ((address > 0x2D) && (address < 0x30)) return 0;
; //if (address > 0x37) return 0;
; 
; // I2C communication
; I2C_Start();
	xcall _I2C_Start
	.dbline 253
; 
; // Write device address
; I2C_TxByte(I2C_ACC_ADDR_W);
	mov A,50
	push A
	xcall _I2C_TxByte
	add SP,-1
	.dbline 254
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 257
; 
; // Write register address
; I2C_TxByte(address);
	mov A,[X-4]
	push A
	xcall _I2C_TxByte
	.dbline 258
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 260
; 
; I2C_RepeatStart();
	xcall _I2C_RepeatStart
	.dbline 263
; 
; // Write device address in read mode
; I2C_TxByte(I2C_ACC_ADDR_R);
	mov A,51
	push A
	xcall _I2C_TxByte
	add SP,-2
	.dbline 264
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 267
; 
; // Read register value
; d = I2C_RxByte();
	xcall _I2C_RxByte
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 268
; I2C_MasterNack();
	xcall _I2C_MasterNack
	.dbline 270
; 
; I2C_Stop();
	xcall _I2C_Stop
	.dbline 272
; 
; return d;
	mov A,[X+0]
	mov REG[0xd0],>__r0
	.dbline -2
L25:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l d 0 c
	.dbsym l address -4 c
	.dbend
	.dbfunc e LSM303_Check_DRDY_Acc _LSM303_Check_DRDY_Acc fc
;         status -> X+0
_LSM303_Check_DRDY_Acc::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 276
; }
; //-----------------------------------------------------------------------
; unsigned char LSM303_Check_DRDY_Acc( void )
; {
	.dbline 278
; 	// Read status register from the LSM303 Acc sensor
; 	unsigned char status = LSM303_RxReg_Acc(0x27); // STATUS_REG_A
	mov A,39
	push A
	xcall _LSM303_RxReg_Acc
	add SP,-1
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 281
; 	
; 	// Check flag ZXYDA to see if a whole set is ready...
; 	return (status & 0x08);
	mov A,[X+0]
	and A,8
	.dbline -2
L26:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l status 0 c
	.dbend
	.dbfunc e LSM303_TxReg_Mag _LSM303_TxReg_Mag fV
;           data -> X-5
;        address -> X-4
_LSM303_TxReg_Mag::
	.dbline -1
	push X
	mov X,SP
	.dbline 287
; }
; //-----------------------------------------------------------------------
; // Magnetic sensor access functions
; //-----------------------------------------------------------------------
; void LSM303_TxReg_Mag(unsigned char address, unsigned char data)
; {
	.dbline 293
; // Check that the target address is not reserved!!!
; // Writing to these registers could damage the device!!!
; //if (address > 0x0C) return;
; 
; // I2C communication
; I2C_Start();
	xcall _I2C_Start
	.dbline 296
; 
; // Write device address
; I2C_TxByte(I2C_MAG_ADDR_W);
	mov A,60
	push A
	xcall _I2C_TxByte
	add SP,-1
	.dbline 297
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 300
; 
; // Write register address
; I2C_TxByte(address);
	mov A,[X-4]
	push A
	xcall _I2C_TxByte
	.dbline 301
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 304
; 
; // Write register value
; I2C_TxByte(data);
	mov A,[X-5]
	push A
	xcall _I2C_TxByte
	add SP,-2
	.dbline 305
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 307
; 
; I2C_Stop();
	xcall _I2C_Stop
	.dbline -2
	.dbline 308
; }
L27:
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l data -5 c
	.dbsym l address -4 c
	.dbend
	.dbfunc e LSM303_RxReg_Mag _LSM303_RxReg_Mag fc
;              d -> X+0
;        address -> X-4
_LSM303_RxReg_Mag::
	.dbline -1
	push X
	mov X,SP
	add SP,1
	.dbline 311
; //-----------------------------------------------------------------------
; unsigned char LSM303_RxReg_Mag(unsigned char address)
; {
	.dbline 312
; unsigned char d = 0x00;
	mov [X+0],0
	.dbline 319
; 
; // Check that the target address is not reserved!!!
; // Writing to these registers could damage the device!!!
; //if (address > 0x0C) return 0;
; 
; // I2C communication
; I2C_Start();
	xcall _I2C_Start
	.dbline 322
; 
; // Write device address
; I2C_TxByte(I2C_MAG_ADDR_W);
	mov A,60
	push A
	xcall _I2C_TxByte
	add SP,-1
	.dbline 323
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 326
; 
; // Write register address
; I2C_TxByte(address);
	mov A,[X-4]
	push A
	xcall _I2C_TxByte
	.dbline 327
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 329
; 
; I2C_RepeatStart();
	xcall _I2C_RepeatStart
	.dbline 332
; 
; // Write device address in read mode
; I2C_TxByte(I2C_MAG_ADDR_R);
	mov A,61
	push A
	xcall _I2C_TxByte
	add SP,-2
	.dbline 333
; I2C_SlaveAck();
	xcall _I2C_SlaveAck
	.dbline 336
; 
; // Read register value
; d = I2C_RxByte();
	xcall _I2C_RxByte
	mov REG[0xd0],>__r0
	mov [X+0],A
	.dbline 337
; I2C_MasterNack();
	xcall _I2C_MasterNack
	.dbline 339
; 
; I2C_Stop();
	xcall _I2C_Stop
	.dbline 341
; 
; return d;
	mov A,[X+0]
	mov REG[0xd0],>__r0
	.dbline -2
L28:
	add SP,-1
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l d 0 c
	.dbsym l address -4 c
	.dbend
	.dbfunc e LSM303_Check_DRDY_Mag _LSM303_Check_DRDY_Mag fc
_LSM303_Check_DRDY_Mag::
	.dbline -1
	.dbline 345
; }
; //-----------------------------------------------------------------------
; unsigned char LSM303_Check_DRDY_Mag()
; {
	.dbline 347
; // Check MDRDY pin. Note that it could also be implemented by reading an internal register...
; return (MAG_DRDY_Data_ADDR & MAG_DRDY_MASK); 
	mov A,REG[ 0]
	mov REG[0xd0],>__r0
	mov [__r0],A
	and [__r0],1
	mov A,[__r0]
	.dbline -2
L29:
	.dbline 0 ; func end
	ret
	.dbend
	.area lit(rom, con, rel)
_Magnetic_X_Y_Table_MSB::
	.word 0
	.word 4031
	.word 8063
	.word 12094
	.word 16126
	.word 20157
	.word 24189
	.word 28220
	.dbsym e Magnetic_X_Y_Table_MSB _Magnetic_X_Y_Table_MSB A[16:8]I
_Magnetic_X_Y_Table_LSB::
	.word 0
	.word 16
	.word 31
	.word 47
	.word 63
	.word 79
	.word 94
	.word 110
	.word 126
	.word 142
	.word 157
	.word 173
	.word 189
	.word 205
	.word 220
	.word 236
	.word 252
	.word 268
	.word 283
	.word 299
	.word 315
	.word 331
	.word 346
	.word 362
	.word 378
	.word 394
	.word 409
	.word 425
	.word 441
	.word 457
	.word 472
	.word 488
	.word 504
	.word 520
	.word 535
	.word 551
	.word 567
	.word 583
	.word 598
	.word 614
	.word 630
	.word 646
	.word 661
	.word 677
	.word 693
	.word 709
	.word 724
	.word 740
	.word 756
	.word 772
	.word 787
	.word 803
	.word 819
	.word 835
	.word 850
	.word 866
	.word 882
	.word 898
	.word 913
	.word 929
	.word 945
	.word 961
	.word 976
	.word 992
	.word 1008
	.word 1024
	.word 1039
	.word 1055
	.word 1071
	.word 1087
	.word 1102
	.word 1118
	.word 1134
	.word 1150
	.word 1165
	.word 1181
	.word 1197
	.word 1213
	.word 1228
	.word 1244
	.word 1260
	.word 1276
	.word 1291
	.word 1307
	.word 1323
	.word 1339
	.word 1354
	.word 1370
	.word 1386
	.word 1402
	.word 1417
	.word 1433
	.word 1449
	.word 1465
	.word 1480
	.word 1496
	.word 1512
	.word 1528
	.word 1543
	.word 1559
	.word 1575
	.word 1591
	.word 1606
	.word 1622
	.word 1638
	.word 1654
	.word 1669
	.word 1685
	.word 1701
	.word 1717
	.word 1732
	.word 1748
	.word 1764
	.word 1780
	.word 1795
	.word 1811
	.word 1827
	.word 1843
	.word 1858
	.word 1874
	.word 1890
	.word 1906
	.word 1921
	.word 1937
	.word 1953
	.word 1969
	.word 1984
	.word 2000
	.word 2016
	.word 2031
	.word 2047
	.word 2063
	.word 2079
	.word 2094
	.word 2110
	.word 2126
	.word 2142
	.word 2157
	.word 2173
	.word 2189
	.word 2205
	.word 2220
	.word 2236
	.word 2252
	.word 2268
	.word 2283
	.word 2299
	.word 2315
	.word 2331
	.word 2346
	.word 2362
	.word 2378
	.word 2394
	.word 2409
	.word 2425
	.word 2441
	.word 2457
	.word 2472
	.word 2488
	.word 2504
	.word 2520
	.word 2535
	.word 2551
	.word 2567
	.word 2583
	.word 2598
	.word 2614
	.word 2630
	.word 2646
	.word 2661
	.word 2677
	.word 2693
	.word 2709
	.word 2724
	.word 2740
	.word 2756
	.word 2772
	.word 2787
	.word 2803
	.word 2819
	.word 2835
	.word 2850
	.word 2866
	.word 2882
	.word 2898
	.word 2913
	.word 2929
	.word 2945
	.word 2961
	.word 2976
	.word 2992
	.word 3008
	.word 3024
	.word 3039
	.word 3055
	.word 3071
	.word 3087
	.word 3102
	.word 3118
	.word 3134
	.word 3150
	.word 3165
	.word 3181
	.word 3197
	.word 3213
	.word 3228
	.word 3244
	.word 3260
	.word 3276
	.word 3291
	.word 3307
	.word 3323
	.word 3339
	.word 3354
	.word 3370
	.word 3386
	.word 3402
	.word 3417
	.word 3433
	.word 3449
	.word 3465
	.word 3480
	.word 3496
	.word 3512
	.word 3528
	.word 3543
	.word 3559
	.word 3575
	.word 3591
	.word 3606
	.word 3622
	.word 3638
	.word 3654
	.word 3669
	.word 3685
	.word 3701
	.word 3717
	.word 3732
	.word 3748
	.word 3764
	.word 3780
	.word 3795
	.word 3811
	.word 3827
	.word 3843
	.word 3858
	.word 3874
	.word 3890
	.word 3906
	.word 3921
	.word 3937
	.word 3953
	.word 3969
	.word 3984
	.word 4000
	.word 4016
	.dbsym e Magnetic_X_Y_Table_LSB _Magnetic_X_Y_Table_LSB A[512:256]I
_Magnetic_Z_Table_MSB::
	.word 0
	.word 4491
	.word 8982
	.word 13474
	.word 17965
	.word 22456
	.word 26947
	.word 31439
	.dbsym e Magnetic_Z_Table_MSB _Magnetic_Z_Table_MSB A[16:8]I
_Magnetic_Z_Table_LSB::
	.word 0
	.word 18
	.word 35
	.word 53
	.word 70
	.word 88
	.word 105
	.word 123
	.word 140
	.word 158
	.word 175
	.word 193
	.word 211
	.word 228
	.word 246
	.word 263
	.word 281
	.word 298
	.word 316
	.word 333
	.word 351
	.word 368
	.word 386
	.word 404
	.word 421
	.word 439
	.word 456
	.word 474
	.word 491
	.word 509
	.word 526
	.word 544
	.word 561
	.word 579
	.word 596
	.word 614
	.word 632
	.word 649
	.word 667
	.word 684
	.word 702
	.word 719
	.word 737
	.word 754
	.word 772
	.word 789
	.word 807
	.word 825
	.word 842
	.word 860
	.word 877
	.word 895
	.word 912
	.word 930
	.word 947
	.word 965
	.word 982
	.word 1000
	.word 1018
	.word 1035
	.word 1053
	.word 1070
	.word 1088
	.word 1105
	.word 1123
	.word 1140
	.word 1158
	.word 1175
	.word 1193
	.word 1211
	.word 1228
	.word 1246
	.word 1263
	.word 1281
	.word 1298
	.word 1316
	.word 1333
	.word 1351
	.word 1368
	.word 1386
	.word 1404
	.word 1421
	.word 1439
	.word 1456
	.word 1474
	.word 1491
	.word 1509
	.word 1526
	.word 1544
	.word 1561
	.word 1579
	.word 1596
	.word 1614
	.word 1632
	.word 1649
	.word 1667
	.word 1684
	.word 1702
	.word 1719
	.word 1737
	.word 1754
	.word 1772
	.word 1789
	.word 1807
	.word 1825
	.word 1842
	.word 1860
	.word 1877
	.word 1895
	.word 1912
	.word 1930
	.word 1947
	.word 1965
	.word 1982
	.word 2000
	.word 2018
	.word 2035
	.word 2053
	.word 2070
	.word 2088
	.word 2105
	.word 2123
	.word 2140
	.word 2158
	.word 2175
	.word 2193
	.word 2211
	.word 2228
	.word 2246
	.word 2263
	.word 2281
	.word 2298
	.word 2316
	.word 2333
	.word 2351
	.word 2368
	.word 2386
	.word 2404
	.word 2421
	.word 2439
	.word 2456
	.word 2474
	.word 2491
	.word 2509
	.word 2526
	.word 2544
	.word 2561
	.word 2579
	.word 2596
	.word 2614
	.word 2632
	.word 2649
	.word 2667
	.word 2684
	.word 2702
	.word 2719
	.word 2737
	.word 2754
	.word 2772
	.word 2789
	.word 2807
	.word 2825
	.word 2842
	.word 2860
	.word 2877
	.word 2895
	.word 2912
	.word 2930
	.word 2947
	.word 2965
	.word 2982
	.word 3000
	.word 3018
	.word 3035
	.word 3053
	.word 3070
	.word 3088
	.word 3105
	.word 3123
	.word 3140
	.word 3158
	.word 3175
	.word 3193
	.word 3211
	.word 3228
	.word 3246
	.word 3263
	.word 3281
	.word 3298
	.word 3316
	.word 3333
	.word 3351
	.word 3368
	.word 3386
	.word 3404
	.word 3421
	.word 3439
	.word 3456
	.word 3474
	.word 3491
	.word 3509
	.word 3526
	.word 3544
	.word 3561
	.word 3579
	.word 3596
	.word 3614
	.word 3632
	.word 3649
	.word 3667
	.word 3684
	.word 3702
	.word 3719
	.word 3737
	.word 3754
	.word 3772
	.word 3789
	.word 3807
	.word 3825
	.word 3842
	.word 3860
	.word 3877
	.word 3895
	.word 3912
	.word 3930
	.word 3947
	.word 3965
	.word 3982
	.word 4000
	.word 4018
	.word 4035
	.word 4053
	.word 4070
	.word 4088
	.word 4105
	.word 4123
	.word 4140
	.word 4158
	.word 4175
	.word 4193
	.word 4211
	.word 4228
	.word 4246
	.word 4263
	.word 4281
	.word 4298
	.word 4316
	.word 4333
	.word 4351
	.word 4368
	.word 4386
	.word 4404
	.word 4421
	.word 4439
	.word 4456
	.word 4474
	.dbsym e Magnetic_Z_Table_LSB _Magnetic_Z_Table_LSB A[512:256]I
	.area text(rom, con, rel)
	.dbfile ./lsm303dlm.c
	.dbfunc e MagSensorToPhysicalVal _MagSensorToPhysicalVal fI
;    physicalVal -> X+2
;            val -> X+0
;          Zaxis -> X-6
;      sensorVal -> X-5
_MagSensorToPhysicalVal::
	.dbline -1
	push X
	mov X,SP
	add SP,4
	.dbline 1450
; }
; 
; //-----------------------------------------------------------------------
; // Conversion tables for magnetic sensor (+/-2.5 Gauss on 12bits)
; //-----------------------------------------------------------------------
; 
; const int Magnetic_X_Y_Table_MSB[8] =
; {
; 0,
; 4031,
; 8063,
; 12094,
; 16126,
; 20157,
; 24189,
; 28220
; };
; 
; const int Magnetic_X_Y_Table_LSB[256] =
; {
; 0,
; 16,
; 31,
; 47,
; 63,
; 79,
; 94,
; 110,
; 126,
; 142,
; 157,
; 173,
; 189,
; 205,
; 220,
; 236,
; 252,
; 268,
; 283,
; 299,
; 315,
; 331,
; 346,
; 362,
; 378,
; 394,
; 409,
; 425,
; 441,
; 457,
; 472,
; 488,
; 504,
; 520,
; 535,
; 551,
; 567,
; 583,
; 598,
; 614,
; 630,
; 646,
; 661,
; 677,
; 693,
; 709,
; 724,
; 740,
; 756,
; 772,
; 787,
; 803,
; 819,
; 835,
; 850,
; 866,
; 882,
; 898,
; 913,
; 929,
; 945,
; 961,
; 976,
; 992,
; 1008,
; 1024,
; 1039,
; 1055,
; 1071,
; 1087,
; 1102,
; 1118,
; 1134,
; 1150,
; 1165,
; 1181,
; 1197,
; 1213,
; 1228,
; 1244,
; 1260,
; 1276,
; 1291,
; 1307,
; 1323,
; 1339,
; 1354,
; 1370,
; 1386,
; 1402,
; 1417,
; 1433,
; 1449,
; 1465,
; 1480,
; 1496,
; 1512,
; 1528,
; 1543,
; 1559,
; 1575,
; 1591,
; 1606,
; 1622,
; 1638,
; 1654,
; 1669,
; 1685,
; 1701,
; 1717,
; 1732,
; 1748,
; 1764,
; 1780,
; 1795,
; 1811,
; 1827,
; 1843,
; 1858,
; 1874,
; 1890,
; 1906,
; 1921,
; 1937,
; 1953,
; 1969,
; 1984,
; 2000,
; 2016,
; 2031,
; 2047,
; 2063,
; 2079,
; 2094,
; 2110,
; 2126,
; 2142,
; 2157,
; 2173,
; 2189,
; 2205,
; 2220,
; 2236,
; 2252,
; 2268,
; 2283,
; 2299,
; 2315,
; 2331,
; 2346,
; 2362,
; 2378,
; 2394,
; 2409,
; 2425,
; 2441,
; 2457,
; 2472,
; 2488,
; 2504,
; 2520,
; 2535,
; 2551,
; 2567,
; 2583,
; 2598,
; 2614,
; 2630,
; 2646,
; 2661,
; 2677,
; 2693,
; 2709,
; 2724,
; 2740,
; 2756,
; 2772,
; 2787,
; 2803,
; 2819,
; 2835,
; 2850,
; 2866,
; 2882,
; 2898,
; 2913,
; 2929,
; 2945,
; 2961,
; 2976,
; 2992,
; 3008,
; 3024,
; 3039,
; 3055,
; 3071,
; 3087,
; 3102,
; 3118,
; 3134,
; 3150,
; 3165,
; 3181,
; 3197,
; 3213,
; 3228,
; 3244,
; 3260,
; 3276,
; 3291,
; 3307,
; 3323,
; 3339,
; 3354,
; 3370,
; 3386,
; 3402,
; 3417,
; 3433,
; 3449,
; 3465,
; 3480,
; 3496,
; 3512,
; 3528,
; 3543,
; 3559,
; 3575,
; 3591,
; 3606,
; 3622,
; 3638,
; 3654,
; 3669,
; 3685,
; 3701,
; 3717,
; 3732,
; 3748,
; 3764,
; 3780,
; 3795,
; 3811,
; 3827,
; 3843,
; 3858,
; 3874,
; 3890,
; 3906,
; 3921,
; 3937,
; 3953,
; 3969,
; 3984,
; 4000,
; 4016
; };
; 
; const int Magnetic_Z_Table_MSB[8] =
; {
; 0,
; 4491,
; 8982,
; 13474,
; 17965,
; 22456,
; 26947,
; 31439
; };
; 
; const int Magnetic_Z_Table_LSB[256] =
; {
; 0,
; 18,
; 35,
; 53,
; 70,
; 88,
; 105,
; 123,
; 140,
; 158,
; 175,
; 193,
; 211,
; 228,
; 246,
; 263,
; 281,
; 298,
; 316,
; 333,
; 351,
; 368,
; 386,
; 404,
; 421,
; 439,
; 456,
; 474,
; 491,
; 509,
; 526,
; 544,
; 561,
; 579,
; 596,
; 614,
; 632,
; 649,
; 667,
; 684,
; 702,
; 719,
; 737,
; 754,
; 772,
; 789,
; 807,
; 825,
; 842,
; 860,
; 877,
; 895,
; 912,
; 930,
; 947,
; 965,
; 982,
; 1000,
; 1018,
; 1035,
; 1053,
; 1070,
; 1088,
; 1105,
; 1123,
; 1140,
; 1158,
; 1175,
; 1193,
; 1211,
; 1228,
; 1246,
; 1263,
; 1281,
; 1298,
; 1316,
; 1333,
; 1351,
; 1368,
; 1386,
; 1404,
; 1421,
; 1439,
; 1456,
; 1474,
; 1491,
; 1509,
; 1526,
; 1544,
; 1561,
; 1579,
; 1596,
; 1614,
; 1632,
; 1649,
; 1667,
; 1684,
; 1702,
; 1719,
; 1737,
; 1754,
; 1772,
; 1789,
; 1807,
; 1825,
; 1842,
; 1860,
; 1877,
; 1895,
; 1912,
; 1930,
; 1947,
; 1965,
; 1982,
; 2000,
; 2018,
; 2035,
; 2053,
; 2070,
; 2088,
; 2105,
; 2123,
; 2140,
; 2158,
; 2175,
; 2193,
; 2211,
; 2228,
; 2246,
; 2263,
; 2281,
; 2298,
; 2316,
; 2333,
; 2351,
; 2368,
; 2386,
; 2404,
; 2421,
; 2439,
; 2456,
; 2474,
; 2491,
; 2509,
; 2526,
; 2544,
; 2561,
; 2579,
; 2596,
; 2614,
; 2632,
; 2649,
; 2667,
; 2684,
; 2702,
; 2719,
; 2737,
; 2754,
; 2772,
; 2789,
; 2807,
; 2825,
; 2842,
; 2860,
; 2877,
; 2895,
; 2912,
; 2930,
; 2947,
; 2965,
; 2982,
; 3000,
; 3018,
; 3035,
; 3053,
; 3070,
; 3088,
; 3105,
; 3123,
; 3140,
; 3158,
; 3175,
; 3193,
; 3211,
; 3228,
; 3246,
; 3263,
; 3281,
; 3298,
; 3316,
; 3333,
; 3351,
; 3368,
; 3386,
; 3404,
; 3421,
; 3439,
; 3456,
; 3474,
; 3491,
; 3509,
; 3526,
; 3544,
; 3561,
; 3579,
; 3596,
; 3614,
; 3632,
; 3649,
; 3667,
; 3684,
; 3702,
; 3719,
; 3737,
; 3754,
; 3772,
; 3789,
; 3807,
; 3825,
; 3842,
; 3860,
; 3877,
; 3895,
; 3912,
; 3930,
; 3947,
; 3965,
; 3982,
; 4000,
; 4018,
; 4035,
; 4053,
; 4070,
; 4088,
; 4105,
; 4123,
; 4140,
; 4158,
; 4175,
; 4193,
; 4211,
; 4228,
; 4246,
; 4263,
; 4281,
; 4298,
; 4316,
; 4333,
; 4351,
; 4368,
; 4386,
; 4404,
; 4421,
; 4439,
; 4456,
; 4474
; };
; 
; //-----------------------------------------------------------------------
; // Conversion tables for magnetic sensor (+/-1.3 Gauss on 12bits)
; //-----------------------------------------------------------------------
; /*
; const int Magnetic_X_Y_Table_MSB[8] =
; {
; 0,
; 2427,
; 4853,
; 7280,
; 9706,
; 12133,
; 14559,
; 16986
; };
; 
; const int Magnetic_X_Y_Table_LSB[256] =
; {
; 0,
; 9,
; 19,
; 28,
; 38,
; 47,
; 57,
; 66,
; 76,
; 85,
; 95,
; 104,
; 114,
; 123,
; 133,
; 142,
; 152,
; 161,
; 171,
; 180,
; 190,
; 199,
; 209,
; 218,
; 227,
; 237,
; 246,
; 256,
; 265,
; 275,
; 284,
; 294,
; 303,
; 313,
; 322,
; 332,
; 341,
; 351,
; 360,
; 370,
; 379,
; 389,
; 398,
; 408,
; 417,
; 427,
; 436,
; 445,
; 455,
; 464,
; 474,
; 483,
; 493,
; 502,
; 512,
; 521,
; 531,
; 540,
; 550,
; 559,
; 569,
; 578,
; 588,
; 597,
; 607,
; 616,
; 626,
; 635,
; 645,
; 654,
; 664,
; 673,
; 682,
; 692,
; 701,
; 711,
; 720,
; 730,
; 739,
; 749,
; 758,
; 768,
; 777,
; 787,
; 796,
; 806,
; 815,
; 825,
; 834,
; 844,
; 853,
; 863,
; 872,
; 882,
; 891,
; 900,
; 910,
; 919,
; 929,
; 938,
; 948,
; 957,
; 967,
; 976,
; 986,
; 995,
; 1005,
; 1014,
; 1024,
; 1033,
; 1043,
; 1052,
; 1062,
; 1071,
; 1081,
; 1090,
; 1100,
; 1109,
; 1118,
; 1128,
; 1137,
; 1147,
; 1156,
; 1166,
; 1175,
; 1185,
; 1194,
; 1204,
; 1213,
; 1223,
; 1232,
; 1242,
; 1251,
; 1261,
; 1270,
; 1280,
; 1289,
; 1299,
; 1308,
; 1318,
; 1327,
; 1336,
; 1346,
; 1355,
; 1365,
; 1374,
; 1384,
; 1393,
; 1403,
; 1412,
; 1422,
; 1431,
; 1441,
; 1450,
; 1460,
; 1469,
; 1479,
; 1488,
; 1498,
; 1507,
; 1517,
; 1526,
; 1536,
; 1545,
; 1555,
; 1564,
; 1573,
; 1583,
; 1592,
; 1602,
; 1611,
; 1621,
; 1630,
; 1640,
; 1649,
; 1659,
; 1668,
; 1678,
; 1687,
; 1697,
; 1706,
; 1716,
; 1725,
; 1735,
; 1744,
; 1754,
; 1763,
; 1773,
; 1782,
; 1791,
; 1801,
; 1810,
; 1820,
; 1829,
; 1839,
; 1848,
; 1858,
; 1867,
; 1877,
; 1886,
; 1896,
; 1905,
; 1915,
; 1924,
; 1934,
; 1943,
; 1953,
; 1962,
; 1972,
; 1981,
; 1991,
; 2000,
; 2009,
; 2019,
; 2028,
; 2038,
; 2047,
; 2057,
; 2066,
; 2076,
; 2085,
; 2095,
; 2104,
; 2114,
; 2123,
; 2133,
; 2142,
; 2152,
; 2161,
; 2171,
; 2180,
; 2190,
; 2199,
; 2209,
; 2218,
; 2227,
; 2237,
; 2246,
; 2256,
; 2265,
; 2275,
; 2284,
; 2294,
; 2303,
; 2313,
; 2322,
; 2332,
; 2341,
; 2351,
; 2360,
; 2370,
; 2379,
; 2389,
; 2398,
; 2408,
; 2417
; };
; 
; const int Magnetic_Z_Table_MSB[8] =
; {
; 0,
; 2695,
; 5389,
; 8084,
; 10779,
; 13474,
; 16168,
; 18863
; };
; 
; const int Magnetic_Z_Table_LSB[256] =
; {
; 0,
; 11,
; 21,
; 32,
; 42,
; 53,
; 63,
; 74,
; 84,
; 95,
; 105,
; 116,
; 126,
; 137,
; 147,
; 158,
; 168,
; 179,
; 189,
; 200,
; 211,
; 221,
; 232,
; 242,
; 253,
; 263,
; 274,
; 284,
; 295,
; 305,
; 316,
; 326,
; 337,
; 347,
; 358,
; 368,
; 379,
; 389,
; 400,
; 411,
; 421,
; 432,
; 442,
; 453,
; 463,
; 474,
; 484,
; 495,
; 505,
; 516,
; 526,
; 537,
; 547,
; 558,
; 568,
; 579,
; 589,
; 600,
; 611,
; 621,
; 632,
; 642,
; 653,
; 663,
; 674,
; 684,
; 695,
; 705,
; 716,
; 726,
; 737,
; 747,
; 758,
; 768,
; 779,
; 789,
; 800,
; 811,
; 821,
; 832,
; 842,
; 853,
; 863,
; 874,
; 884,
; 895,
; 905,
; 916,
; 926,
; 937,
; 947,
; 958,
; 968,
; 979,
; 989,
; 1000,
; 1011,
; 1021,
; 1032,
; 1042,
; 1053,
; 1063,
; 1074,
; 1084,
; 1095,
; 1105,
; 1116,
; 1126,
; 1137,
; 1147,
; 1158,
; 1168,
; 1179,
; 1189,
; 1200,
; 1211,
; 1221,
; 1232,
; 1242,
; 1253,
; 1263,
; 1274,
; 1284,
; 1295,
; 1305,
; 1316,
; 1326,
; 1337,
; 1347,
; 1358,
; 1368,
; 1379,
; 1389,
; 1400,
; 1411,
; 1421,
; 1432,
; 1442,
; 1453,
; 1463,
; 1474,
; 1484,
; 1495,
; 1505,
; 1516,
; 1526,
; 1537,
; 1547,
; 1558,
; 1568,
; 1579,
; 1589,
; 1600,
; 1611,
; 1621,
; 1632,
; 1642,
; 1653,
; 1663,
; 1674,
; 1684,
; 1695,
; 1705,
; 1716,
; 1726,
; 1737,
; 1747,
; 1758,
; 1768,
; 1779,
; 1789,
; 1800,
; 1811,
; 1821,
; 1832,
; 1842,
; 1853,
; 1863,
; 1874,
; 1884,
; 1895,
; 1905,
; 1916,
; 1926,
; 1937,
; 1947,
; 1958,
; 1968,
; 1979,
; 1989,
; 2000,
; 2011,
; 2021,
; 2032,
; 2042,
; 2053,
; 2063,
; 2074,
; 2084,
; 2095,
; 2105,
; 2116,
; 2126,
; 2137,
; 2147,
; 2158,
; 2168,
; 2179,
; 2189,
; 2200,
; 2211,
; 2221,
; 2232,
; 2242,
; 2253,
; 2263,
; 2274,
; 2284,
; 2295,
; 2305,
; 2316,
; 2326,
; 2337,
; 2347,
; 2358,
; 2368,
; 2379,
; 2389,
; 2400,
; 2411,
; 2421,
; 2432,
; 2442,
; 2453,
; 2463,
; 2474,
; 2484,
; 2495,
; 2505,
; 2516,
; 2526,
; 2537,
; 2547,
; 2558,
; 2568,
; 2579,
; 2589,
; 2600,
; 2611,
; 2621,
; 2632,
; 2642,
; 2653,
; 2663,
; 2674,
; 2684
; };
; */
; //-----------------------------------------------------------------------------
; // Scaling the Magnetic sensor value  
; //-----------------------------------------------------------------------------
; int MagSensorToPhysicalVal(int sensorVal, unsigned char Zaxis)
; {
	.dbline 1455
; unsigned int val;
; int physicalVal;
; 
; // Test if read value is negative or positive
; if (sensorVal & 0x0800) 
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,0
	mov [__r1],A
	mov A,[X-5]
	and A,8
	cmp A,0
	jnz X2
	cmp [__r1],0
	jz L31
X2:
	.dbline 1456
; {
	.dbline 1457
; 	val = (unsigned int)((~sensorVal) + 1); //(sensorVal * -1); // * -1 could be optimized by (~val)+1 ... To be tested... 
	mov REG[0xd0],>__r0
	mov A,[X-4]
	cpl A
	mov [__r1],A
	mov A,[X-5]
	cpl A
	mov [__r0],A
	add [__r1],1
	adc [__r0],0
	mov A,[__r1]
	mov [X+1],A
	mov A,[__r0]
	mov [X+0],A
	.dbline 1458
; }
	xjmp L32
L31:
	.dbline 1459
; else val = (unsigned int)sensorVal;
	mov A,[X-4]
	mov [X+1],A
	mov A,[X-5]
	mov [X+0],A
L32:
	.dbline 1462
; 
; // Apply look table to scale absolute value...
; if (Zaxis)
	cmp [X-6],0
	jz L33
	.dbline 1463
; {
	.dbline 1464
; 	physicalVal = Magnetic_Z_Table_MSB[(unsigned char)((val & 0x0f00) >> 8)] + Magnetic_Z_Table_LSB[(unsigned char)(val & 0x00ff)];
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_Magnetic_Z_Table_LSB
	adc [__r0],>_Magnetic_Z_Table_LSB
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X+0]
	and A,15
	mov [__r3],A
	mov [__r2],0
	asl [__r3]
	rlc [__r2]
	add [__r3],<_Magnetic_Z_Table_MSB
	adc [__r2],>_Magnetic_Z_Table_MSB
	mov A,[__r2]
	push X
	push A
	mov X,[__r3]
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	add A,[__r1]
	mov [X+3],A
	mov A,[__r2]
	adc A,[__r0]
	mov [X+2],A
	.dbline 1465
; }
	xjmp L34
L33:
	.dbline 1467
; else
; {
	.dbline 1468
; 	physicalVal = Magnetic_X_Y_Table_MSB[(unsigned char)((val & 0x0f00) >> 8)] + Magnetic_X_Y_Table_LSB[(unsigned char)(val & 0x00ff)];
	mov REG[0xd0],>__r0
	mov A,[X+1]
	mov [__r1],A
	mov [__r0],0
	asl [__r1]
	rlc [__r0]
	add [__r1],<_Magnetic_X_Y_Table_LSB
	adc [__r0],>_Magnetic_X_Y_Table_LSB
	mov A,[__r0]
	push X
	push A
	mov X,[__r1]
	romx
	mov [__r0],A
	pop A
	inc X
	adc A,0
	romx
	mov [__r1],A
	pop X
	mov A,[X+0]
	and A,15
	mov [__r3],A
	mov [__r2],0
	asl [__r3]
	rlc [__r2]
	add [__r3],<_Magnetic_X_Y_Table_MSB
	adc [__r2],>_Magnetic_X_Y_Table_MSB
	mov A,[__r2]
	push X
	push A
	mov X,[__r3]
	romx
	mov [__r2],A
	pop A
	inc X
	adc A,0
	romx
	pop X
	add A,[__r1]
	mov [X+3],A
	mov A,[__r2]
	adc A,[__r0]
	mov [X+2],A
	.dbline 1469
; }
L34:
	.dbline 1472
; 
; // If input was negative reset sign...
; if (sensorVal & 0x0800) 
	mov REG[0xd0],>__r0
	mov A,[X-4]
	and A,0
	mov [__r1],A
	mov A,[X-5]
	and A,8
	cmp A,0
	jnz X3
	cmp [__r1],0
	jz L35
X3:
	.dbline 1473
; {
	.dbline 1475
; 	//physicalVal *= -1; // * -1 could be optimized by (~val)+1 ... To be tested... 
; 	physicalVal = ((~physicalVal) + 1);
	mov REG[0xd0],>__r0
	mov A,[X+3]
	cpl A
	mov [__r1],A
	mov A,[X+2]
	cpl A
	mov [__r0],A
	mov A,[__r1]
	add A,1
	mov [X+3],A
	mov A,[__r0]
	adc A,0
	mov [X+2],A
	.dbline 1476
; } 
L35:
	.dbline 1478
; 
; return physicalVal; 
	mov REG[0xd0],>__r0
	mov A,[X+3]
	mov [__r1],A
	mov A,[X+2]
	mov [__r0],A
	.dbline -2
L30:
	add SP,-4
	pop X
	.dbline 0 ; func end
	ret
	.dbsym l physicalVal 2 I
	.dbsym l val 0 i
	.dbsym l Zaxis -6 c
	.dbsym l sensorVal -5 I
	.dbend
